extends "res://Scripts/Interactor.gd"

@onready var crosshair = Node2D.new()
var crosshair_size = 4.0
var crosshair_thickness = 1.0
var crosshair_color = Color(1, 1, 1, 0.8)

func _ready():
	add_child(crosshair)
	crosshair.set_as_top_level(true)
	crosshair.draw.connect(_draw_crosshair)

func _physics_process(delta):
	super(delta)
	if is_colliding() and !gameData.interface:
		var collision_point = get_collision_point()
		var camera = get_viewport().get_camera_3d()
		if camera:
			var screen_point = camera.unproject_position(collision_point)
			crosshair.position = screen_point
			crosshair.visible = true
	else:
		crosshair.visible = false
	crosshair.queue_redraw()

func _draw_crosshair():
	if crosshair.visible:
		crosshair.draw_line(
			Vector2(-crosshair_size, -crosshair_size),
			Vector2(crosshair_size, crosshair_size),
			crosshair_color,
			crosshair_thickness
		)
		crosshair.draw_line(
			Vector2(crosshair_size, -crosshair_size),
			Vector2(-crosshair_size, crosshair_size),
			crosshair_color,
			crosshair_thickness
		)
		crosshair.draw_circle(Vector2.ZERO, crosshair_size/2.0, Color(0, 0, 0, 0.8))